/*
     Object Oriented Programming using C++,
     Solution Manual and Applied Examples.
	    written by Dr. Farschad Torabi
     K. N. Toosi University of Technology  
	           September, 2013

                Chapter 22
       Code written by: Razieh Hamedi
*/

#include<stdio.h>
#include<iostream>
#include<math.h>
using namespace std;
class shape
{
public:
  double v,M,Q,I,t,a,b,L,P,W,d1,d2,x,h,NA,NB,Vtension,Ttension;
  //------------------------------
  void g ()
  {
    cout<<"enter the parameters (a,L,P,W,d1,d2)"<<endl;
    cout<<"(a,L,P,W,d1,d2)="<<endl;
    cin>>a;cin>>L;cin>>P;cin>>W;cin>>d1;cin>>d2;
  }
  //------------------------------
  void calNB()
  {
    NB=(P*a+0.5*W*(d2*d2-d1*d1))/L;
  }
  //------------------------------
  void calNA()
  {
    NA=W*(d2-d1)+P-NB;
  }
  //------------------------------
  void calVMAX()
  {
    v=max(NB,NA);
  }
  //------------------------------
  void calMMAX()
  {
    if(v=NA)
    {
      M=NA*d1;
    }
    else 
    {
      M=NB*(L-a);}
  }
  //------------------------------
  void MAXvertical_tension()
  {
    Vtension=((M*(0.5)*h)/I);
    cout<<"Vtension="<<Vtension<<endl;
  }
  //------------------------------
  void MAXtangential_tension()
  {
    Ttension=((v*Q)/(I*t));
    cout<<"Ttension="<<Ttension<<endl;
  }
  //------------------------------
  virtual void calI()=0;
  virtual void calQ()=0;
  virtual void calt()=0;
  virtual void information()=0;
};

//--- CLASS RECTANGLE 
class RECTANGLE:public shape
{
public:
  virtual void information()
  {
    cout<<"enter the parameter(b,h)"<<endl;
    cout<<"(b,h)="<<endl;
    cin>>b;
    cin>>h;
  }
  //----------------------------
  virtual void calI()
  {
    I=(1.0/12)*b*h*h*h;
  }
  //----------------------------
  virtual void calt()
  {
    t=b;
  }
  //----------------------------
  virtual void calQ()
  {
    Q=(0.25)*h*h*(0.5)*b;
  }
};

//--- CLASS I 
class Ishape:public shape
{
public:
  double t1,t2; 
  virtual void information()
  {
    cout<<"enter the parameters(b,h,t1,t2)"<<endl;
    cout<<"(b,h,t1,t2)="<<endl;
    cin>>b;cin>>h;cin>>t1;cin>>t2;
  }
  //------------------------------
  virtual void calI()
  {
    I=(1.0/12)*b*h*h*h-2*((1/12)*(b-t2)*(0.5)*(h-2*t1)*(h-2*t1)*(h-2*t1));
  }
  //------------------------------
  virtual void calt()
  {
    t=t2;
  }
  //------------------------------
  virtual void calQ()
  {
    Q=(0.5)*(h-t1)*t1*b+(0.5)*t2*((0.5)*h-t1)*((0.5)*h-t1);
  }
};
//------ END OF CLASSES  ---------

int main()
{

  int valid = 0;
  shape * sh;
  int type;

  while(!valid)
  {
    system("cls");
    cout<<"'RECTANGLE' = 1 "<<endl;
    cout<<"'IShape   ' = 2 "<<endl;
    cout<<"enter your type:"<<endl;
    cin>>type;
    switch(type)
    {
    case(2):
      {
        sh =  new Ishape;
        valid = 1;
        break;
      }
    case(1):
      {
        sh =  new RECTANGLE;
        valid = 1;
        break;
      }
    }
  }
  sh->g();
  sh->calNB();
  sh->calNA();
  sh->calVMAX();
  sh->calMMAX();
  sh->information();
  sh->calI();
  sh->calt();
  sh->calQ();
  sh->MAXvertical_tension();
  sh->MAXtangential_tension(); 

  return 0;
}

